﻿Public Class Form1

    Private Reader As SlotReader

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Me.Left = -9000
        Me.Opacity = 0
        Me.Left = 0
        Text = AppTitleAndVersion("")
        ' --------------------------------------------------------
        If CanUseWindowsDlls() Then
            MemoryMappedFile_Init()
        Else
            MemoryMappedFile_Init_Unix()
        End If
        ' --------------------------------------------------------
        Combo_InitFromEnum(cmb_Spec_Window, GetType(FHT.WindowTypes))
        cmb_Spec_Window.SelectedIndex = 15
        ' --------------------------------------------------------
        Load_INI()
        ' --------------------------------------------------------
        Scope.Initialize(pbox_Scope)
        ScopeTrim()
        Spectrum.Initialize(pbox_Spectrum)
        SetSpectrumWindowType()
        ' --------------------------------------------------------
        Timer1.Interval = 50
        Timer1.Start()
        ' -------------------------------------------------------- 
        Reader = New SlotReader
        ' -------------------------------------------------------- 
        EventsAreEnabled = True
        ' ---------------------------------------------------------------- start UserInterface
        Show()
        Refresh()
        Me.Opacity = 100
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Reader.Destroy()
        Scope.CloseAll()
        Spectrum.CloseAll()
        Save_INI()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        UpdateAll()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        UpdateAll()
    End Sub

    Private SpectrumWindowType As FHT.WindowTypes
    Private Sub UpdateAll()
        ReportString = ""
        ' ----------------------------------------------------- 
        Scope.Update(pbox_Scope, chk_ScopeNeg.Checked)
        Spectrum.Update(pbox_Spectrum, _
                        CSng(txt_SpecMinFreq.NumericValue), _
                        CSng(txt_SpecMaxFreq.NumericValue), _
                        CSng(txt_SpecMinDb.NumericValue), _
                        CSng(txt_SpecMaxDb.NumericValue), _
                        chk_SpecLogX.Checked, _
                        chk_SpecLogY.Checked, _
                        txt_SpecSpeed.NumericValueInteger / 100.0F, _
                        SpectrumWindowType)
        ' -----------------------------------------------------
        If ReportString <> "" Then Text = ReportString
    End Sub


    ' ===================================================================================================
    '  USER PARAMS 
    ' ===================================================================================================

    Private Sub SaveParamsOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                                    Handles tbar_ScopeVoltage.LostFocus, _
                                                                                            tbar_ScopeTime.LostFocus, _
                                                                                            chk_ScopeNeg.LostFocus, _
                                                                                            txt_SpecMaxDb.LostFocus, _
                                                                                            txt_SpecMinDb.LostFocus, _
                                                                                            txt_SpecMaxFreq.LostFocus, _
                                                                                            txt_SpecMinFreq.LostFocus, _
                                                                                            txt_SpecSpeed.LostFocus, _
                                                                                            chk_SpecLogX.LostFocus, _
                                                                                            chk_SpecLogY.LostFocus, _
                                                                                            cmb_Spec_Window.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub Gen_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SpecMaxFreq.TextChanged, _
                                                                                                            txt_SpecMinFreq.TextChanged
        If Not EventsAreEnabled Then Return
        Dim txt As CustomControlsLib.MyTextBox
        txt = DirectCast(sender, CustomControlsLib.MyTextBox)
        If txt.NumericValue >= 1000 Then
            txt.Decimals = 0
            txt.ArrowsIncrement = 100
            txt.Increment = 1
            txt.RoundingStep = 100
        ElseIf txt.NumericValue >= 100 Then
            txt.Decimals = 0
            txt.ArrowsIncrement = 10
            txt.Increment = 1
            txt.RoundingStep = 10
        Else
            txt.Decimals = 0
            txt.ArrowsIncrement = 1
            txt.Increment = 1
            txt.RoundingStep = 0
        End If
    End Sub

    Private Sub AllCombo_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Spec_Window.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub

    Private Sub AllCombo_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Spec_Window.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub

    Private Sub cmb_Spec_Window_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                Handles cmb_Spec_Window.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetSpectrumWindowType()
        GroupBox_Scope.Focus()
    End Sub

    Private Sub SetSpectrumWindowType()
        SpectrumWindowType = CType(cmb_Spec_Window.SelectedIndex, FHT.WindowTypes)
    End Sub

    Private Sub tbar_ScopeParams_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                        Handles tbar_ScopeVoltage.Scroll, _
                                                                                tbar_ScopeTime.Scroll
        If Not EventsAreEnabled Then Return
        ScopeTrim()
    End Sub

    Private Sub ScopeTrim()
        Scope.SetVoltage(VoltageFromTrackBar(tbar_ScopeVoltage.Value))
        Scope.SetTime(TimeFromTrackBar(tbar_ScopeTime.Value))
    End Sub

    Private Function VoltageFromTrackBar(ByVal n As Int32) As Single
        Select Case n
            Case 0 : Return 500
            Case 1 : Return 250
            Case 2 : Return 200
            Case 3 : Return 100
            Case 4 : Return 50
            Case 5 : Return 25
            Case 6 : Return 20
            Case 7 : Return 10
            Case 8 : Return 5
            Case 9 : Return 2.5
            Case 10 : Return 2
            Case 11 : Return 1
        End Select
    End Function

    Private Function TimeFromTrackBar(ByVal n As Int32) As Single
        Select Case n
            Case 0 : Return 500
            Case 1 : Return 200
            Case 2 : Return 100
            Case 3 : Return 50
            Case 4 : Return 20
            Case 5 : Return 10
        End Select
    End Function

End Class
